package de.hdm_stuttgart.battlearena.Persistance.Classes;

import de.hdm_stuttgart.battlearena.Exceptions.DatabaseError;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;

public class AzureDB implements IDataBase{

    /*this class is only here for showcasing the interchangeability of the DBMS*/

    private static final Logger log = LogManager.getLogger(OracleDB.class);

    @Override
    public Connection connect() throws DatabaseError {
        try {
            String url = "jdbc:sqlserver://battlearena.database.windows.net;encrypt=true;user=battleArenaAdmin;password=krassesRPGGame23#;databaseName=battleArena;";

            log.info("Connecting to the database!");
            Connection connection = DriverManager.getConnection(url);
            log.info("Database connection test" + connection.getCatalog());

            connection.setAutoCommit(true);

            return connection;
        }
        catch(Exception e){
            log.error(e);
            throw new DatabaseError("SQL Connection Error");
        }
    }

    @Override
    public ArrayList<MapData> getCoreMaps() throws DatabaseError{
        try(Connection connection = connect()) {
            ArrayList<MapData> newMaps = new ArrayList<MapData>();
            String sql = "SELECT * FROM CoreMaps";
            PreparedStatement stmt = connection.prepareStatement(sql);

            log.info("Sending SQL statement");
            ResultSet rs = stmt.executeQuery();

            while(rs.next()){
                newMaps.add(new MapData(rs.getString("map_id"), rs.getString("map_name"), rs.getInt("map_width"), rs.getInt("map_height"), rs.getString("map_data")));
            }
            log.info("SQL query successful");
            rs.close();
            stmt.close();
            return newMaps;
        }
        catch(Exception e){
            log.error(e);
            throw new DatabaseError("Error retrieving Coremaps");
        }
    }

    public ArrayList<String> getCommunityMapsList() throws DatabaseError{
        try(Connection connection = connect()) {
            ArrayList<String> tempList = new ArrayList<String>();
            String sql = "SELECT map_name FROM CommunityMaps";
            PreparedStatement stmt = connection.prepareStatement(sql);

            log.info("Sending SQL statement");
            ResultSet rs = stmt.executeQuery();

            while(rs.next()){
                tempList.add(rs.getString("map_name"));
            }
            log.info("SQL query successful");
            rs.close();
            stmt.close();
            return tempList;
        }
        catch(Exception e){
            log.error(e);
            throw new DatabaseError("Error retrieving MapList");
        }
    }


}
