package de.hdm_stuttgart.battlearena.Persistance.Classes;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

import java.sql.Connection;
import java.util.ArrayList;

public class Persistence {

    private static final Logger log = LogManager.getLogger(Persistence.class);
    private static final Persistence persistenceSingleton = new Persistence();
    private final GsonHandler gsonHandler = new GsonHandler();
    private final DBalt sqlHandler = new DBalt(); //??
    private Connection connection;          //??
    protected ArrayList<MapData> coreMaps;
    protected ArrayList<MapData> communityMaps;
    private final String filePathCoreMaps = "src/main/resources/maps/coreMaps.json";
    private final String filePathCommunityMaps = "src/main/resources/maps/communityMaps.json";
    private int[] sizeArrayInt;             //??
    private String sizeString;              //??
    protected static PlayerStatistics statistics = new PlayerStatistics("", 0,0,0,0,0,0);
    //suggestion: rename to "playerData"


    OracleDB db = new OracleDB(); //for testing purposes; evtl. Methoden von OracleDB static machen und von GSON Handler


    private Persistence (){}

    public static Persistence getInstance(){
        return persistenceSingleton;
    }

    public void loadCoreMaps(){
        try {
            coreMaps = gsonHandler.loadMaps(filePathCoreMaps);
            log.info("Maps successfully loaded from file");
            //log.info(coreMaps.get(0).getMapName());                 //for testing purposes
        }
        catch(Exception e){
            log.error(e);
        }
    }

    public void updateCoreMaps(){
        try {
            coreMaps = db.getCoreMaps();
            gsonHandler.saveMaps(coreMaps, filePathCoreMaps);
            log.info("Maps successfully updated from SQL-Server");
            //log.info(coreMaps.get(0).getMapName());                 //for testing purposes
        }
        catch(Exception e){
            log.error(e);
        }
    }

    public void getCommunityMap(String mapSelected){
        try {
            communityMaps.add(db.getCommunityMapByID(mapSelected));
            gsonHandler.saveMaps(communityMaps, filePathCommunityMaps);
            log.info("Community Map successfully retrieved from SQL-Server!");
        }
        catch(Exception e){
            log.error(e);
        }
    }

    public void uploadCommunityMap(MapData map){
        try {
            db.uploadCommunityMapByID(map);
            communityMaps.add(map);         //hier noch prüfen, ob die Map lokal bereits existiert (falls eine Verbindung zur DB scheitern sollte, kann man sie dennoch lokal speichern
            gsonHandler.saveMaps(communityMaps, filePathCommunityMaps);
            log.info("Maps successfully updated from SQL-Server!");
        }
        catch(Exception e){
            log.error(e);
        }
    }

    public void createPlayer (){
    }

    public void loadStatistics(){
    }

}
