--Note: DDL to be run as admin on OracleDB; Passwords for user accounts are not included and must be inserted before execution

DROP TABLE battlearenadata.coremaps;
DROP TABLE battlearenadata.communitymaps;

DROP USER battlearenaplayer;
DROP USER battlearenadata;

CREATE USER battlearenaplayer IDENTIFIED BY "insertPasswordHere";
CREATE USER battlearenadata IDENTIFIED BY "insertPasswordHere";

GRANT CONNECT TO battlearenaplayer;

CREATE TABLE battlearenadata.coremaps(
                                         map_id CHAR(40) NOT NULL UNIQUE, --SHA1 hash is 40 chars length in hex
                                         map_name VARCHAR(30) NOT NULL,
                                         map_width INTEGER NOT NULL,
                                         map_height INTEGER NOT NULL,
                                         map_data VARCHAR(1682) NOT NULL); --allows for map size up to 29x29

CREATE TABLE battlearenadata.communitymaps(
                                              map_id CHAR(40) NOT NULL UNIQUE, --SHA1 hash is 40 chars length in hex
                                              map_name VARCHAR(30) NOT NULL,
                                              map_width INTEGER NOT NULL,
                                              map_height INTEGER NOT NULL,
                                              map_data VARCHAR(1682) NOT NULL);  --allows for map size up to 29x29

ALTER USER battlearenadata QUOTA 500M ON coremaps;
ALTER USER battlearenadata QUOTA 500M ON communitymaps;

INSERT INTO battlearenadata.coremaps (map_id, map_name, map_width, map_height, map_data)
VALUES ('a593cafd1d061f0f463a2d2051bf4718aaaf5c48',
        'Arena1',
        18,
        18,
        '4 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 4 1 2 1 1 1 1 2 2 2 1 1 1 1 1 1 1 3 4 2 1 1 1 1 1 2 2 2 1 1 1 1 2 1 1 3 4 1 1 1 2 2 4 3 3 1 4 3 3 3 3 2 2 3 4 1 1 1 2 2 4 1 1 1 1 1 1 1 3 1 2 3 4 1 1 1 2 2 4 1 3 3 3 1 1 1 3 2 2 3 4 1 1 1 2 2 4 1 1 1 1 1 1 1 3 2 1 3 4 1 1 1 2 2 4 3 3 1 4 3 3 3 3 2 1 3 4 1 1 1 1 1 1 2 2 2 1 1 1 1 1 1 1 3 4 1 1 1 2 2 4 3 3 1 3 3 3 3 3 2 1 3 4 1 1 1 1 2 4 3 3 1 3 3 3 3 3 1 1 3 4 1 1 1 1 2 4 3 3 1 3 3 3 3 3 2 2 3 4 1 1 1 1 1 4 3 3 1 3 3 3 3 3 1 2 3 4 1 2 1 1 1 1 2 2 2 1 1 1 1 1 1 1 3 4 1 1 2 1 1 1 2 2 2 1 1 1 1 1 1 1 3 4 1 1 1 2 2 4 3 3 1 3 3 3 3 3 2 2 3 4 1 1 1 2 2 4 3 3 1 3 3 3 3 3 2 2 3 4 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3');

INSERT INTO battlearenadata.coremaps (map_id, map_name, map_width, map_height, map_data)
VALUES ('e559d8fbb53b333f5839cb3c6c0c515395afe344',
        'Arena2',
        18,
        18,
        '4 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 4 1 2 1 1 1 1 2 2 2 1 1 1 1 1 1 1 2 4 2 1 1 1 1 1 2 2 2 1 1 1 1 2 3 1 3 4 1 1 1 2 2 4 3 3 1 4 3 3 3 3 2 2 3 4 1 1 1 2 2 4 1 1 1 1 1 1 1 3 1 2 3 4 1 1 1 2 2 4 1 3 3 3 1 1 1 3 2 2 3 4 1 1 1 2 2 4 1 1 1 1 1 1 1 3 2 1 3 4 1 1 1 2 2 4 3 3 1 4 3 3 3 3 2 1 3 4 1 1 1 1 1 1 2 2 2 1 1 1 1 1 1 1 3 4 1 1 1 2 2 4 3 3 1 3 3 3 3 3 2 1 3 4 1 1 1 1 2 4 3 3 1 3 3 3 3 3 1 1 3 4 1 1 1 1 2 4 3 3 1 3 3 3 3 3 2 2 3 4 1 1 1 1 1 4 3 3 1 3 3 3 3 3 1 2 3 4 1 2 1 1 1 1 2 2 2 1 1 1 1 1 1 1 3 4 1 1 2 1 1 1 2 2 2 1 1 1 1 1 1 1 3 4 1 1 1 2 2 4 3 3 1 3 3 3 3 3 2 2 3 4 1 1 1 2 2 4 3 3 1 3 3 3 3 3 2 2 3 4 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3');


GRANT SELECT ON battlearenadata.coremaps TO battlearenaplayer;

GRANT SELECT, INSERT ON battlearenadata.communitymaps TO battlearenaplayer;